# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2019-01-29.      #
#                                                           #
# Ruby Bindings Version 2.1.21                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Passive infrared (PIR) motion sensor, 12m range
  class BrickletMotionDetectorV2 < Device
    DEVICE_IDENTIFIER = 292 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Motion Detector Bricklet 2.0' # :nodoc:

    # This callback is called after a motion was detected.
    CALLBACK_MOTION_DETECTED = 6

    # This callback is called when the detection cycle ended. When this
    # callback is called, a new motion can be detected again after approximately 2
    # seconds.
    CALLBACK_DETECTION_CYCLE_ENDED = 7

    FUNCTION_GET_MOTION_DETECTED = 1 # :nodoc:
    FUNCTION_SET_SENSITIVITY = 2 # :nodoc:
    FUNCTION_GET_SENSITIVITY = 3 # :nodoc:
    FUNCTION_SET_INDICATOR = 4 # :nodoc:
    FUNCTION_GET_INDICATOR = 5 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    MOTION_NOT_DETECTED = 0 # :nodoc:
    MOTION_DETECTED = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_MOTION_DETECTED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSITIVITY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSITIVITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_INDICATOR] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_INDICATOR] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_MOTION_DETECTED] = ''
      @callback_formats[CALLBACK_DETECTION_CYCLE_ENDED] = ''

    end

    # Returns 1 if a motion was detected. How long this returns 1 after a motion
    # was detected can be adjusted with one of the small potentiometers on the
    # Motion Detector Bricklet, see :ref:`here
    # <motion_detector_bricklet_sensitivity_delay_block_time>`.
    # 
    # There is also a blue LED on the Bricklet that is on as long as the Bricklet is
    # in the "motion detected" state.
    def get_motion_detected
      send_request FUNCTION_GET_MOTION_DETECTED, [], '', 1, 'C'
    end

    # Sets the sensitivity of the PIR sensor. The range is 0-100. At full
    # sensitivity (100), the Bricklet can detect motion in a range of approximately 12m.
    # 
    # The actual range depends on many things in the environment (e.g. reflections) and the
    # size of the object to be detected. While a big person might be detected in a range
    # of 10m a cat may only be detected at 2m distance with the same setting.
    # 
    # So you will have to find a good sensitivity for your application by trial and error.
    # 
    # The default value is 50.
    def set_sensitivity(sensitivity)
      send_request FUNCTION_SET_SENSITIVITY, [sensitivity], 'C', 0, ''
    end

    # Returns the sensitivity as set by BrickletMotionDetectorV2#set_sensitivity.
    def get_sensitivity
      send_request FUNCTION_GET_SENSITIVITY, [], '', 1, 'C'
    end

    # Sets the blue backlight of the fresnel lens. The backlight consists of
    # three LEDs. The brightness of each LED can be controlled with a 8-bit value
    # (0-255). A value of 0 turns the LED off and a value of 255 turns the LED
    # to full brightness.
    # 
    # The default value is 0, 0, 0.
    def set_indicator(top_left, top_right, bottom)
      send_request FUNCTION_SET_INDICATOR, [top_left, top_right, bottom], 'C C C', 0, ''
    end

    # Returns the indicator configuration as set by BrickletMotionDetectorV2#set_indicator.
    def get_indicator
      send_request FUNCTION_GET_INDICATOR, [], '', 3, 'C C C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 16, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 1, 'C'
    end

    # Returns the current bootloader mode, see BrickletMotionDetectorV2#set_bootloader_mode.
    def get_bootloader_mode
      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 1, 'C'
    end

    # Sets the firmware pointer for BrickletMotionDetectorV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 0, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletMotionDetectorV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 1, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 0, ''
    end

    # Returns the configuration as set by BrickletMotionDetectorV2#set_status_led_config
    def get_status_led_config
      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 1, 'C'
    end

    # Returns the temperature in °C as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 2, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      send_request FUNCTION_RESET, [], '', 0, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      send_request FUNCTION_WRITE_UID, [uid], 'L', 0, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      send_request FUNCTION_READ_UID, [], '', 4, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
